/* -*- Mode: C++; tab-width: 8; indent-tabs-mode: t; c-basic-offset: 8 -*- */

/* SlideShow
 *
 * Authors:
 *      Alvaro Lopez Ortega <alvaro@alobbs.com>
 *
 * Copyright (C) 2002-2003 Alvaro Lopez Ortega
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 * USA
 */

#include "Eraser.h"
#include <string.h>


Eraser::Eraser (unsigned int color) :
	slideshow::Drawable()
{
	r = (color & 0xFF0000) >> 16;
	g = (color & 0x00FF00) >> 8;
	b = (color & 0x0000FF);
}


void
Eraser::Draw (SDL_Surface *screen)
{
	Uint8 *p = ((Uint8 *)(screen->pixels));

	for (int i=0; i< screen->w*screen->h; i++) {
		unsigned int offset = (i * screen->format->BytesPerPixel);

		p[offset]   = r;
		p[offset+1] = g;
		p[offset+2] = b;
	}
}


string
Eraser::ToPython (void) const
{
	return "";
}


string
Eraser::ToXML (void) const
{
	return "";
}


string
Eraser::ToCPP (void) const
{
	return "";
}
