/* -*- Mode: C++; tab-width: 8; indent-tabs-mode: t; c-basic-offset: 8 -*- */

/* SlideShow
 *
 * Authors:
 *      Alvaro Lopez Ortega <alvaro@alobbs.com>
 *
 * Copyright (C) 2002-2003 Alvaro Lopez Ortega
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 * USA
 */

#ifndef __Fires__
#define __Fires__

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include "Drawable.h"



class Fires : public slideshow::Drawable {
public:
	   SET_CLASS(Fires);
	   
	   Fires (int screen_width=DEFAULT_WIDTH, int screen_height=DEFAULT_HEIGHT, int whichmap=0, bool trans=true);
	   ~Fires();

	   void SetTransparent (bool value);

	   virtual void Draw (SDL_Surface *screen);

	   virtual string ToPython (void) const;
	   virtual string ToXML    (void) const;
	   virtual string ToCPP    (void) const;

private:
	   struct blob {
			 struct blob *blobnext;
			 int blobx;
			 int bloby;
			 int blobdx;
			 int blobdy;
			 int bloblife;
			 int blobsize;
	   };

	   int XSIZE;
	   int YSIZE;
	   
	   SDL_Rect dest;

	   unsigned char *vmem1, *vmem2;
	   SDL_Color themap[256];
	   int explodenum,k;
	   char sizes[8];
	   char *remap,*remap2;
	   unsigned char *p1, *p2;
	   blob  *blobs,*freeblobs,*activeblobs;
	   
	   unsigned char **mul640;
	   int oldmode;
	   int now, frames;
	   int flash;
	   
	   void fire(unsigned char *p1,unsigned char *p2,int pitch,char *map);
	   void disk(int x, int y, int rad);
	   void addblob(void);
	   void moveblobs(void);
	   void putblobs(void);
	   void normal(char *map);
	   void bright(char *map);
	   void updatemap(void);
	   void loadcolor(int n,int r,int g,int b);
	   void loadcolors(unsigned int which);
};

#endif // __Fires__
