/* -*- Mode: C++; tab-width: 8; indent-tabs-mode: t; c-basic-offset: 8 -*- */

/* SlideShow
 *
 * Authors:
 *      Alvaro Lopez Ortega <alvaro@alobbs.com>
 *
 * Copyright (C) 2002-2003 Alvaro Lopez Ortega
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 * USA
 */


#include <iostream>
#include <string>
#include "FontVault.h"

using namespace std;


FontVault::FontVault ()
{
	fonts.clear();
}


FontVault::~FontVault ()
{
	   for (Fonts_HashMap::iterator it = fonts.begin(); it!=fonts.end(); ++it) {
		   TTF_CloseFont ((*it).second);
	   }
}


void
FontVault::Load (const char *name, const char *filename, int size)
{
	string s_name;
	s_name = name;

	TTF_Font *f = TTF_OpenFont (filename, size);

	   if (!f) {
		   cerr << "Can't load font: " << filename << " " << size << endl;
		   return;
	   }
	   
	   fonts[s_name] = f;
}


TTF_Font *
FontVault::Get (const char *fontname)
{
	   string s_fontname(fontname);
	   
	   Fonts_HashMap::iterator it = fonts.find (s_fontname);
	   if (it == fonts.end()) return NULL;

	   return (*it).second;
}


TTF_Font *
FontVault::GetFirstOne (void)
{
	   Fonts_HashMap::iterator it1 = fonts.begin();
	   Fonts_HashMap::iterator it2 = fonts.end();

	   if (it1 == it2) {
		   return NULL;
	   }

	   return (*it1).second;
}
