/* -*- Mode: C++; tab-width: 8; indent-tabs-mode: t; c-basic-offset: 8 -*- */

/* SlideShow
 *
 * Authors:
 *      Alvaro Lopez Ortega <alvaro@alobbs.com>
 *
 * Copyright (C) 2002-2003 Alvaro Lopez Ortega
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 * USA
 */


#ifndef __Gradient__
#define __Gradient__

#include <SDL.h>
#include "Drawable.h"


typedef enum {
	   GRADIENT_VERTICAL,
	   GRADIENT_HORIZONTAL,
} SlideShowGradient;

class Gradient : public slideshow::Drawable {
public:
	   SET_CLASS(Gradient);
	   
	   Gradient (int color1, int color2, SlideShowGradient type=GRADIENT_VERTICAL);

	   virtual void Draw (SDL_Surface *screen);
	   virtual string ToPython (void) const;
	   virtual string ToXML    (void) const;
	   virtual string ToCPP    (void) const;
	   
protected:
	   Uint32 color1;
	   Uint32 color2;

	   SlideShowGradient type;

	   void DrawVertical (SDL_Surface *screen,
					  Uint8 r1, Uint8 g1, Uint8 b1,
					  Uint8 r2, Uint8 g2, Uint8 b2);
	   
	   void DrawHorizontal (SDL_Surface *screen,
					    Uint8 r1, Uint8 g1, Uint8 b1,
					    Uint8 r2, Uint8 g2, Uint8 b2);
};


#endif // __Gradient__
