/* -*- Mode: C++; tab-width: 8; indent-tabs-mode: t; c-basic-offset: 8 -*- */

/* SlideShow
 *
 * Authors:
 *      Alvaro Lopez Ortega <alvaro@alobbs.com>
 *
 * Copyright (C) 2002-2003 Alvaro Lopez Ortega
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 * USA
 */


#include "Macros.h"
#include "Gradient.h"
#include "GradientAnimated.h"

//
#include <iostream>
using namespace std;
//



GradientAnimated::GradientAnimated (int color1, int color2, SlideShowGradient type) :
	   Gradient (color1, color2, type)
{
	   original1 = color1;	   
	   COLOR_TO_RGB(color1,r1,g1,b1);

	   original2 = color2;
	   COLOR_TO_RGB(color2,r2,g2,b2);

	   speed = 20;
	   if (r1>r2 && g1>g2 && b1>b2) {
			 speed *= -1;
	   }

	   gettimeofday(&begin, NULL);
}

	   
GradientAnimated::~GradientAnimated()
{
}


void
GradientAnimated::Draw (SDL_Surface *screen)
{
	   struct timeval now;
	   gettimeofday(&now, NULL);
	   
	   double elapse = (((double)now.tv_sec + (double)now.tv_usec/(1000*1000)) -
					((double)begin.tv_sec + (double)begin.tv_usec/(1000*1000)));
	   
	   int pixels = elapse * speed;
	   bool change = false;

	   /* Red */
	   
	   
	   if ((r+pixels) > MIN(r1,r2) && (r+pixels) < MAX(r1,r2)) {
			 r+=pixels;
			 change = true;
	   }
	   if ((g+pixels) > MIN(g1,g2) && (g+pixels) < MAX(g1,g2)) {
			 g+=pixels;
			 change = true;
	   }
	   if ((b+pixels) > MIN(b1,b2) && (b+pixels) < MAX(b1,b2)) {
			 b+=pixels;
			 change = true;
	   }

	   cout << "r " << r << " g " << g << " b " << b << " speed " << speed << endl;
	   
	   
	   if (change) {
			 speed *= -1;
	   }
	   
	   Gradient::Draw (screen);
}
