/* -*- Mode: C++; tab-width: 8; indent-tabs-mode: t; c-basic-offset: 8 -*- */

/* SlideShow
 *
 * Authors:
 *      Alvaro Lopez Ortega <alvaro@alobbs.com>
 *
 * Copyright (C) 2002-2003 Alvaro Lopez Ortega
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 * USA
 */


#ifndef __GradientAnimated__
#define __GradientAnimated__

#include "Gradient.h"


class GradientAnimated : public Gradient {
public:
	   SET_CLASS(GradientAnimated);
	   
	   GradientAnimated (int color1, int color2, SlideShowGradient type=GRADIENT_VERTICAL);
	   ~GradientAnimated();

	   virtual void Draw (SDL_Surface *screen);

protected:
	   int speed;
	   
	   Uint8 r,g,b;

	   Uint32 original1;
	   Uint8  or1,og1,ob1;
	   Uint32 original2;
	   Uint8  or2,og2,ob2;

	   Uint8 r2,g2,b2;
	   Uint8 r1,g1,b1;

	   struct timeval begin;
};


#endif // __GradientAnimated__
