/* -*- Mode: C++; tab-width: 8; indent-tabs-mode: t; c-basic-offset: 8 -*- */

/* SlideShow
 *
 * Authors:
 *      Alvaro Lopez Ortega <alvaro@alobbs.com>
 *
 * Copyright (C) 2002-2003 Alvaro Lopez Ortega
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 * USA
 */

#ifndef __GtkPresentation__
#define __GtkPresentation__

#include <gtk/gtk.h>
#include "Presentation.h"
#include "XmlLoader.h"


class GtkPresentation {
public:
	   GtkPresentation (int *argc, char ***argv);
	   ~GtkPresentation();

	   void Load (char *filename);
	   
protected:
	   Presentation *presentation;

	   
private:
	   XmlLoader xml_loader;
	   GtkWidget *mainwin;
	   GtkWidget *sdl_widget;
	   GtkWidget *menu;
	   guint      idle_id;
	   
// Friend functions for event handlers
public:
	   friend gboolean delete_event_cb (GtkWidget *widget, GdkEventAny *event);
	   friend gboolean idle_loop (gpointer data);
	   friend gboolean button_quit_clicked (GtkWidget *widget, GdkEventAny *event, gpointer data);
	   friend gboolean gtk_sdl_redraw (GtkWidget *widget, GdkEvent *event, gpointer user_data);
	   friend gboolean menu_load_file (gpointer callback_data, guint callback_action, GtkWidget *widget);
	   friend gboolean menu_export_html (gpointer callback_data, guint callback_action, GtkWidget *widget);
	   friend gboolean menu_export_html_ok_clicked (GtkWidget *widget, gpointer data);
	   friend gboolean menu_quit (gpointer callback_data, guint callback_action, GtkWidget *widget);

};


#endif // __GtkPresentation__
