/* -*- Mode: C++; tab-width: 8; indent-tabs-mode: t; c-basic-offset: 8 -*- */

/* SlideShow
 *
 * Authors:
 *      Alvaro Lopez Ortega <alvaro@alobbs.com>
 *
 * Copyright (C) 2002-2003 Alvaro Lopez Ortega
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 * USA
 */

#ifndef __HandDrawing__
#define __HandDrawing__

#include <SDL.h>
#include "Drawable.h"


class HandDrawing : public slideshow::Drawable {
public:
	   HandDrawing (unsigned int color=0xFF);
	   ~HandDrawing();

	   void AddPoint (Uint16 x, Uint16 y);
	   
	   virtual void Draw (SDL_Surface *screen);
	   virtual string ToPython (void) const;
	   virtual string ToXML    (void) const;
	   virtual string ToCPP    (void) const;
	   
protected:
	   unsigned int color;

	   Uint16 *points;
	   Uint32  points_number;
	   Uint32  points_last;

private:
	   void DrawPixel (SDL_Surface *, Uint16 x, Uint16 y);
	   void DrawLine  (SDL_Surface *, Uint16 x1, Uint16 y1, Uint16 x2, Uint16 y2);
	   void bresenham_line(SDL_Surface *, Uint32 x1, Uint32 y1, Uint32 x2, Uint32 y2);
};

#endif // __HandDrawing__
