/* -*- Mode: C++; tab-width: 8; indent-tabs-mode: t; c-basic-offset: 8 -*- */

/* SlideShow
 *
 * Authors:
 *      Alvaro Lopez Ortega <alvaro@alobbs.com>
 *
 * Copyright (C) 2002-2003 Alvaro Lopez Ortega
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 * USA
 */

#ifndef __HtmlExporter__
#define __HtmlExporter__


#include "Presentation.h"
#include "Exporter.h"


#define HTML_EXPORTER_HEADER 	\
"<?xml version=\"1.0\"?> \n" \
"<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.1//EN\" \"http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd\"> \n\n" \
"<html xmlns=\"http://www.w3.org/1999/xhtml\"> \n" \
"<head><title>slideshow</title></head> \n" \
"<body>"

#define HTML_EXPORTER_FOOT \
"</body></html>"


class HtmlExporter : public Exporter {
public:
	   HtmlExporter ();
	   ~HtmlExporter();

	   virtual void Write (Presentation *pre, const char *prefix);

private:
	   void SaveThumbnail (const char *f_bmp, const char *png_path_wo_suf);
	   void WriteHTML     (int i, int total, const char *path_wo_suf);
	   void WriteIndex    (int total, const char *prefix);
};


#endif // __HtmlExporter__
