/* -*- Mode: C++; tab-width: 8; indent-tabs-mode: t; c-basic-offset: 8 -*- */

/* SlideShow
 *
 * Authors:
 *      Alvaro Lopez Ortega <alvaro@alobbs.com>
 *
 * Copyright (C) 2002-2003 Alvaro Lopez Ortega
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 * USA
 */


#include "Image.h"
#include <SDL_image.h>
#include <iostream>

using namespace std;


Image::Image (char *filename) :
	slideshow::Drawable()
{
	if (filename != NULL) {
		Load (filename);
	}
}


void 
Image::Load (const char *filename)
{
	if (surface) SDL_FreeSurface(surface);
	
	surface = IMG_Load (filename);
	
	if (!surface) {
		cerr << "Can't load '" << filename << "': " << IMG_GetError() << endl;
	}
}


string
Image::ToPython (void) const
{
	return "";
}


string
Image::ToXML (void) const
{
	return "";
}


string
Image::ToCPP (void) const
{
	return "";
}
