%option c++
%option noyywrap
%option yyclass="MgpLoader"

%{
#include <string>
#include "MgpLoader.h"
	   
#undef YY_DECL
#define YY_DECL int MgpLoader::NextToken()

#define nooo_YY_DECL MgpToken MgpLoader::NextToken()
%}

digit        [0-9]
alpha        [A-Za-z]
alphanumeric {alpha}|{digit}
ident        {alpha}({alphanumeric})*
number       ({digit})*
space        [\n\ \t\b\r\f]

N       (-[0-9]+|[0-9]+|(0x|0X)[0-9A-Fa-f]+)
JISIN   (\033$B|\033$@)
ASCIIIN (\033\(B|\033\(J)
ASTR    [\040-\176]*
ASTRN   [\040\041\043-\176]*
JSTR    {JISIN}([\041-\176][\041-\176])*{ASCIIIN}
XSTR    [\240-\377]*

%%


(page|PAGE) { /* return MGP_PAGE; */ }
EOF         { /* return MGP_EOF; */ }


%%