/* -*- Mode: C++; tab-width: 8; indent-tabs-mode: t; c-basic-offset: 8 -*- */

/* SlideShow
 *
 * Authors:
 *      Alvaro Lopez Ortega <alvaro@alobbs.com>
 *
 * Copyright (C) 2002-2003 Alvaro Lopez Ortega
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 * USA
 */

#ifndef __Mpeg__
#define __Mpeg__

#include <SDL.h>
#include <smpeg.h>
#include "Drawable.h"



class Mpeg : public slideshow::Drawable {
public:
	   SET_CLASS(Mpeg);
	   
	   Mpeg (const char *filename = NULL);
	   ~Mpeg();
	   
	   void Load (const char *filename);

	   virtual bool NeedRedraw (void);

	   virtual string ToPython (void) const;
	   virtual string ToXML    (void) const;
	   virtual string ToCPP    (void) const;
	   
protected:
	   SMPEG_Info    info;
	   SMPEG        *mpeg;
	   SMPEG_Filter *filter;
	   
private:
	   Uint32 LastMagicNum;
	   Uint32 CalculateMagicNum(void);
	   void   SetErrorBox (void);

// Events
protected:
	   virtual void On_JoiningPage (void);
	   virtual void On_LeavingPage (void);
	  
};


#endif // __Mpeg__
