/* -*- Mode: C++; tab-width: 8; indent-tabs-mode: t; c-basic-offset: 8 -*- */

/* SlideShow
 *
 * Authors:
 *      Alvaro Lopez Ortega <alvaro@alobbs.com>
 *
 * Copyright (C) 2002-2003 Alvaro Lopez Ortega
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 * USA
 */

#include "Namer.h"

#include <iostream>
using namespace std;


Namer::Namer()
{
	   for (int i=0; i<ClassType_NUMBER; i++) {
			 counter[i] = 0;
	   }
}


Namer::~Namer()
{
}


string *
Namer::GetName (Drawable *item, Uint32 page)
{
	   SS_ASSERT (item);
	   SS_ASSERT (GET_CLASS(item) < ClassType_NUMBER);

	   char tmp_[100];
	   char *tmp = &tmp[0];
	   if (!item->name) {
			 counter[GET_CLASS(item)]++;

		 	 // FIXME:
			 // Make it works with std::string. Without snprintf and char *
			 snprintf (tmp, 100, "p%i_%s%i", page, GET_CLASS_NAME(item).c_str(), counter[GET_CLASS(item)]);
			 printf ("nombre %s\n", tmp);

			 /*
			 item->name = new string();
			 item->name->append(tmp);
			 */
			 item->name = new string();
			 item->name->assign(tmp);
	   }

	   cout << "Name " << item->name << endl;
	   return item->name;
}
