/* -*- Mode: C++; tab-width: 8; indent-tabs-mode: t; c-basic-offset: 8 -*- */

/* SlideShow
 *
 * Authors:
 *      Alvaro Lopez Ortega <alvaro@alobbs.com>
 *
 * Copyright (C) 2002-2003 Alvaro Lopez Ortega
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 * USA
 */

#ifndef __Scroll__
#define __Scroll__

#include <SDL.h>
#include <sys/time.h>


enum Direction {
	   NONE,
	   SOUTH_NORTH,
	   NORTH_SOUTH,
	   EAST_WEST,
	   WEST_EAST
};


class Scroll {
public:
	   Scroll (int w, int h, int *x, int *y, int direction, int stop_at, int another_pos, int pixels_per_second);

	   void Move (void);
	   void MakeFinish (void);
	   
	   bool Finished (void);

	   
protected:
	   int *x, *y;
	   int direction;
	   int stop_at;
	   int start_at;
	   int pps;
	   
	   bool finished;
	   bool last_move;
	   
	   //time_t begin;
	   struct timeval begin;
};


#endif // __Scroll__
