#include "Spinner.h"
#include "Macros.h"
#include "sge.h"

#include <iostream>
using namespace std;


#define SLIDESHOW_DEFAULT_DEGREES_PER_SECOND  90
#define SLIDESHOW_DEFAULT_DEFRESS_MAX        361 // looping


Spinner::Spinner(Drawable *parent) :
	   Effect (parent)
{
	   degrees = 0;
	   DegreesPerSecond = SLIDESHOW_DEFAULT_DEGREES_PER_SECOND;
	   DegreesMax       = SLIDESHOW_DEFAULT_DEFRESS_MAX;
	   
	   gettimeofday(&begin, NULL);
}


Spinner::~Spinner()
{
}


void
Spinner::SayCheese (void)
{
	   degrees = 0;
}


void
Spinner::Draw (SDL_Surface *screen)
{
	   SS_ASSERT (parent_surface);

	   // Max degrees reached
	   if (degrees >= DegreesMax) {
			 Drawable::Draw (screen);
			 return;
	   }

	   if (surface && surface != parent_surface) {
			 SDL_FreeSurface (surface);
			 surface = NULL;
	   }
	   
	   ProcessEffect();

	   int x_back = x;
	   int y_back = y;

	   if (parent_surface->w < surface->w) {
			 x = x - (surface->w - parent_surface->w)/2;
	   } else if (parent_surface->w > surface->w) {
			 x = x + (parent_surface->w - surface->w)/2;
	   }
	   
	   if (parent_surface->h < surface->h) {
			 y = y - (surface->h - parent_surface->h)/2;
	   } else if (parent_surface->h > surface->h) {
			 y = y + (parent_surface->h - surface->h)/2;
	   }
	   
	   Drawable::Draw (screen);

	   x = x_back;
	   y = y_back;

	   need_redraw = true;
}


void
Spinner::ProcessEffect (void)
{
	   struct timeval now;
	   gettimeofday(&now, NULL);

	   double elapse = (((double)now.tv_sec + (double)now.tv_usec/(1000*1000)) -
					((double)begin.tv_sec + (double)begin.tv_usec/(1000*1000)));
	   
	   degrees = (int)(DegreesPerSecond * elapse) % 360;

	   surface = sge_transform_surface (parent_surface,
								 0, // color
								 degrees,
								 1, // x	
								 1, // y	
								 0);
}


string
Spinner::ToPython (void) const
{
	return "";
}


string
Spinner::ToXML (void) const
{
	return "";
}


string
Spinner::ToCPP (void) const
{
	return "";
}
