/* -*- Mode: C++; tab-width: 8; indent-tabs-mode: t; c-basic-offset: 8 -*- */

/* SlideShow
 *
 * Authors:
 *      Alvaro Lopez Ortega <alvaro@alobbs.com>
 *
 * Copyright (C) 2002-2003 Alvaro Lopez Ortega
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 * USA
 */

#include "Types.h"

#include <iostream>
using namespace std;


string
SlideShow_ClassType2string (SlideShow_ClassType t)
{
	   string name;
	   
	   switch (t) {
	   case ClassType_Drawable: name += "Drawable"; break;
	   case ClassType_Effect: name += "Effect"; break;
	   case ClassType_EffectDarkness: name += "EffectDarkness"; break;
	   case ClassType_Eraser: name += "Eraser"; break;
	   case ClassType_Fires: name += "Fires"; break;
	   case ClassType_Gradient: name += "Gradient"; break;
	   case ClassType_GradientAnimated: name += "GradientAnimated"; break;
	   case ClassType_Image: name += "Image"; break;
	   case ClassType_Mpeg: name += "Mpeg"; break;
	   case ClassType_Page: name += "Page"; break;
	   case ClassType_Plasma: name += "Plasma"; break;
	   case ClassType_Presentation: name += "Presentation"; break;
	   case ClassType_ProgressiveShow: name += "ProgressiveShow"; break;
	   case ClassType_Spinner: name += "Spinner"; break;
	   case ClassType_Stars: name += "Stars"; break;
	   case ClassType_Text: name += "Text"; break;
	   case ClassType_TextDouble: name += "TextDouble"; break;
	   case ClassType_Writer: name += "Writer"; break;
	   default:
			 cerr << "This should not happend: " << __FILE__ << ", line " << __LINE__ << endl;
	   }

	   return name;
}
