/* -*- Mode: C++; tab-width: 8; indent-tabs-mode: t; c-basic-offset: 8 -*- */

/* SlideShow
 *
 * Authors:
 *      Alvaro Lopez Ortega <alvaro@alobbs.com>
 *
 * Copyright (C) 2002-2003 Alvaro Lopez Ortega
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 * USA
 */

#ifndef __SlideShow_Types__
#define __SlideShow_Types__

#include <string>
using std::string;

// Only Drawable based classes
// 
typedef enum {
	   ClassType_Drawable = 0,
	   ClassType_Effect,
	   ClassType_EffectDarkness,
	   ClassType_Eraser,
	   ClassType_Fires,
	   ClassType_Gradient,
	   ClassType_GradientAnimated,
	   ClassType_Image,
	   ClassType_Mpeg,
	   ClassType_Page,
	   ClassType_Plasma,
	   ClassType_Presentation,
	   ClassType_ProgressiveShow,
	   ClassType_Spinner,
	   ClassType_Stars,
	   ClassType_Text,
	   ClassType_TextDouble,
	   ClassType_Writer,
	   ClassType_UpDown,

	   ClassType_NUMBER
} SlideShow_ClassType;



string SlideShow_ClassType2string (SlideShow_ClassType);

#endif // __SlideShow_Types__
